var tabQuestions = [];
var indexQuestion = 0;
var tabReponses = [];

function chargerListeCategories() {
    $.getJSON(
            '../Controleurs/controleur.php',
            {action: 'getCategories'}
    )
            .done(function (donnees, stat, xhr) {
                // Ajouter l'option par défaut avec Bootstrap
                $("#lstCategories").append($("<option>", {value: "-1", class: "text-muted"}).text("Choisissez une catégorie"));

                // Ajouter les options pour chaque compétence
                $.each(donnees, function (index, ligne) {
                    $("#lstCategories").append($("<option>", {value: ligne[0], class: "text-dark"}).text(ligne[1]));
                });
            })
            .fail(function (xhr, text, error) {
                console.log("param : " + JSON.stringify(xhr));
                console.log("status : " + text);
                console.log("error : " + error);
            });
}

function afficherQuestion()
{
    if (indexQuestion >= 0 && indexQuestion < 5)
    {
        $("#question").text("Question " + (1 + indexQuestion) + " / 5");
        $("#question").append("<br>" + tabQuestions[indexQuestion].texte);
        $("#question").append("<br><input type=\"text\" placeholder=\"votre réponse\">");
        $("#question").append("<input type=\"hidden\" value=\"" + tabQuestions[indexQuestion].id + "\">");
        $("#question").append("<span class=\"btn btn-primary valide\">Valider</span>");
        $("#question input[type='text']").focus();

    }

}
function ajouterReponse(e)
{
    e.preventDefault();
    function normaliserTexte(texte) {
        return texte
                .trim() // retirer les espaces
                .toLowerCase() // mettre en minuscule
                .normalize("NFD") // décomposer les lettres accentuées
                .replace(/[\u0300-\u036f]/g, ""); // supprimer les diacritiques (accents)
    }
    var reponse = $('input[type="text"]').val();
    var id = $('input[type="hidden"]').val();
    tabReponses.push({id: id, reponse: reponse});
    indexQuestion++;
    if (indexQuestion == 5)
    {
        indexQuestion = 0;
        //console.log(tabQuestions);
        //console.log(tabReponses);
        // fin de quizz
        // calculer scores
        var score = 0;
        $.each(tabQuestions, function (index, question) {
            // trouver la réponse correspondant à la question
            var rep = tabReponses.find(r => r.id == question.id);

            if (
                    rep &&
                    normaliserTexte(rep.reponse) ==
                    normaliserTexte(String(question.reponse))
                    ) {
                score++;
            }


        });
        console.log("score : " + score);
        var idCat = $("#lstCategories option:selected").val();

        majScore(score, idCat);
    } else
    {
        afficherQuestion();
    }
}
function chargerQuestions()
{
    var idCat = $("#lstCategories option:selected").val();
    var nomCat = $("#lstCategories option:selected").text();
    if (idCat != -1)
    {
        $("#choixCat").hide();
        $.getJSON(
                '../Controleurs/controleur.php',
                {action: 'getQuestionsQuiz',
                    idCat: idCat}
        )
                .done(function (donnees, stat, xhr) {

                    $("#question").text("");

                    $.each(donnees, function (index, ligne) {
                        tabQuestions.push(ligne);
                    });
                    indexQuestion = 0;
                    afficherQuestion();

                })
                .fail(function (xhr, text, error) {
                    console.log("param : " + JSON.stringify(xhr));
                    console.log("status : " + text);
                    console.log("error : " + error);
                });
    }

}
function majScore(score, idCat) {
    // Affichage esthétique du score
    const scoreHtml = `
        <div id="affichageScore" class="alert alert-success text-center mt-4" role="alert" style="font-size: 1.5rem;">
            🏆 Votre score est de <strong>${score} / 5</strong> !
        </div>
    `;

    // Affiche le message de score
    $("#question").html(scoreHtml);
    $("#choixCat").hide(); // Cache choixCat au cas où il serait encore visible

    // Envoi des données en AJAX
    $.ajax({
        type: 'POST',
        url: '../Controleurs/controleur.php',
        data: {
            action: 'majScore',
            score: score,
            idCat: idCat
        },
        success: function (response) {
            // Nettoyage après 5 secondes
            setTimeout(function () {
                $("#affichageScore").fadeOut(800, function () {
                    $(this).remove();
                    $("#choixCat").fadeIn(800);
                });

                // Réinitialise les tableaux
                tabQuestions = [];
                tabReponses = [];
            }, 5000);
        },
        error: function () {
            showMessage("Erreur lors de l'inscription.", "danger");
        }
    });
}

function majScoreOld(score, idCat)
{

    $("#question").text("Votre score est de " + score + " / 5 ");
    $.ajax({
        type: 'POST',
        url: '../Controleurs/controleur.php',
        data: {
            action: 'majScore',
            score: score,
            idCat: idCat
        },
        success: function (response) {
            tabQuestions = [];
            tabReponses = [];
            $("#choixCat").show();
        },
        error: function () {
            showMessage("Erreur lors de l'inscription.", "danger");
        }
    });
}
function getPseudo()
{
    $.getJSON(
            '../Controleurs/controleur.php',
            {action: 'getPseudo'
            }
    )
            .done(function (donnees, stat, xhr) {

                $("#pseudo").append(donnees);
                $("#user").val(donnees);
                if (donnees == "admin")
                {
                    $("#navbarJeu ul").append('<li class="nav-item"><a class="nav-link" href="admin_categories.php" id="navAdm">Admin</a>                        </li>')
                }

            })
            .fail(function (xhr, text, error) {
                console.log("param : " + JSON.stringify(xhr));
                console.log("status : " + text);
                console.log("error : " + error);
            });
}
function deconnexion()
{
    $.ajax({
        type: 'POST',
        url: '../Controleurs/controleur.php',
        data: {
            action: 'deconnexion'
        },
        success: function (response) {
            window.location.href = "index.php";
        },
        error: function () {
            showMessage("Erreur lors de l'inscription.", "danger");
        }
    });
}

function formaterDateFr(isoDate) {
    const options = {
        weekday: 'long',
        year: 'numeric',
        month: 'long',
        day: 'numeric',
        hour: '2-digit',
        minute: '2-digit'
    };
    const date = new Date(isoDate);
    return date.toLocaleDateString('fr-FR', options);
}

function classement()
{
    $("#classement").show();
    $("#choixCat").hide();
    $("#question").empty();
    tabQuestions = [];
    tabReponses = [];
    // affichage du classement global
    $.getJSON(
            '../Controleurs/controleur.php',
            {action: 'getCategories'
            }
    )
            .done(function (donnees, stat, xhr) {
                $.each(donnees, function (index, ligne) {
                    $("#filtreCategorie").append($("<option>", {value: ligne[0]}).text(ligne[1]));
                });


            })
            .fail(function (xhr, text, error) {
                console.log("param : " + JSON.stringify(xhr));
                console.log("status : " + text);
                console.log("error : " + error);
            });
    // affichage du classement par categorie
    function chargerClassement(idCategorie = 0) {
        var urlComplete = window.location.href;
        var basePath = urlComplete.substring(0, urlComplete.lastIndexOf("/") + 1);
        var urlJsonFr = basePath + "/libs/datatables/fr-FR.json";
        $.getJSON('../Controleurs/controleur.php', {
            action: 'getClassement',
            idCat: idCategorie
        })
                .done(function (donnees) {
                    let table = $('#tableClassement').DataTable({
                        destroy: true,
                        order: [[3, 'desc']], // Colonne 3 = Score total (0 = pseudo)
                        language: {
                            url: urlJsonFr
                        }
                    });
                    table.clear();

                    $.each(donnees, function (index, ligne) {
                        table.row.add([
                            ligne.pseudo,
                            ligne.nom_type,
                            ligne.nb_parties, // nouveau champ
                            ligne.score_total,
                            formaterDateFr(ligne.horodatage)
                        ]);
                    });

                    table.draw();
                });
    }
    /***************************/

    function chargerDonneesGraphiques() {
        $.getJSON('../Controleurs/controleur.php', {action: 'getMeilleursScoresParCategorie'})
                .done(function (data) {
                    afficherGraphiques(data);
                })
                .fail(function (xhr, text, error) {
                    console.error("Erreur lors de la récupération des données pour les graphiques : " + error);
                });
    }

    function afficherGraphiques(data) {
        // Créer un conteneur pour les graphiques
        const graphContainer = $('<div id="graphiques" class="row mt-3"></div>');
        $("#classement").append(graphContainer);

        $.each(data, function (categorie, meilleursScores) {
            if (meilleursScores.length > 0) {
                const chartData = [];
                $.each(meilleursScores, function (index, score) {
                    chartData.push({
                        name: score.pseudo,
                        y: parseInt(score.score_total) // Assurez-vous que le score est un nombre
                    });
                });

                const chartId = `chart-${categorie.replace(/\s+/g, '-').toLowerCase()}`;
                const chartDiv = $(`<div class="col-md-6"><div id="${chartId}"></div></div>`);
                graphContainer.append(chartDiv);

                Highcharts.chart(chartId, {
                    chart: {
                        type: 'pie'
                    },
                    title: {
                        text: `Meilleurs scores - ${categorie}`
                    },
                    tooltip: {
                        pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
                    },
                    accessibility: {
                        point: {
                            valueSuffix: '%'
                        }
                    },
                    plotOptions: {
                        pie: {
                            allowPointSelect: true,
                            cursor: 'pointer',
                            dataLabels: {
                                enabled: true,
                                format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                                connectorColor: 'silver'
                            }
                        }
                    },
                    series: [{
                            name: 'Score',
                            data: chartData
                        }]
                });
            } else {
                graphContainer.append(`<div class="col-md-6"><p>Pas de données de score disponibles pour la catégorie ${categorie}.</p></div>`);
            }
        });
    }
    /******************************/

    $('#tableClassement').DataTable();
    chargerClassement();
    chargerDonneesGraphiques();

    $(document).on('change', '#filtreCategorie', function () {
        let idCat = $(this).val();
        chargerClassement(idCat);
    });

}
function jouer()
{
    $("#classement").hide();
    $("#choixCat").show();
    $("#question").empty();
    tabQuestions = [];
    tabReponses = [];
}
$(document).ready(function () {
    chargerListeCategories();
    $(document).on('click', '#start', chargerQuestions);
    $(document).on('click', '.valide', ajouterReponse);
    $(document).on('click', '#navDeconnexion', deconnexion);
    $(document).on('click', '#navClassement', classement);
    $(document).on('click', '#navJeu', jouer);
    $(document).on('submit', 'form', ajouterReponse);
    getPseudo();
    $("#classement").hide();
    // gestion du active de la navbar
    $(".navbar-nav .nav-link").on("click", function () {
        $(".navbar-nav .nav-link").removeClass("active"); // Retire 'active' de tous les liens
        $(this).addClass("active"); // Ajoute 'active' au lien cliqué
    });


});

